#!/usr/bin/perl

package CodonTable;
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
#author mt
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*


my %rev_complementary;
$rev_complementary{"CTA"} = "TAG";
$rev_complementary{"TTA"} = "TAA";
$rev_complementary{"TCA"} = "TGA";
#reverse stop with degenerated nucs
$rev_complementary{"NNN"} = "NNN";

$rev_complementary{"CTN"} = "NAG";
$rev_complementary{"CGN"} = "NCG";
$rev_complementary{"CAN"} = "NTG";
$rev_complementary{"CCN"} = "NGG";

$rev_complementary{"AGN"} = "NCT";
$rev_complementary{"ATN"} = "NAT";
$rev_complementary{"ACN"} = "NGT";
$rev_complementary{"AAN"} = "NTT";

$rev_complementary{"TGN"} = "NCA";
$rev_complementary{"TAN"} = "NTA";
$rev_complementary{"TCN"} = "NGA";
$rev_complementary{"TTN"} = "NAA";

$rev_complementary{"GGN"} = "NCC";
$rev_complementary{"GTN"} = "NAC";
$rev_complementary{"GAN"} = "NTC";
$rev_complementary{"GCN"} = "NGC";

$rev_complementary{"CNN"} = "NNG";
$rev_complementary{"TNN"} = "NNA";
$rev_complementary{"ANN"} = "NNT";
$rev_complementary{"GNN"} = "NNC";

$rev_complementary{"NTN"} = "NAN";
$rev_complementary{"NCN"} = "NGN";
$rev_complementary{"NGN"} = "NCN";
$rev_complementary{"NAN"} = "NTN";

$rev_complementary{"NNA"} = "TNN";
$rev_complementary{"NNT"} = "ANN";
$rev_complementary{"NNG"} = "CNN";
$rev_complementary{"NNC"} = "GNN";

$rev_complementary{"CNA"} = "TNG";
$rev_complementary{"CNG"} = "CNG";
$rev_complementary{"CNT"} = "ANG";
$rev_complementary{"CNC"} = "GNG";

$rev_complementary{"GNA"} = "TNC";
$rev_complementary{"GNT"} = "ANG";
$rev_complementary{"GNG"} = "CNC";
$rev_complementary{"GNC"} = "GNC";

$rev_complementary{"ANA"} = "TNT";
$rev_complementary{"ANT"} = "ANT";
$rev_complementary{"ANG"} = "CNT";
$rev_complementary{"ANC"} = "GNT";

$rev_complementary{"TNA"} = "TNA";
$rev_complementary{"TNG"} = "CNA";
$rev_complementary{"TNC"} = "GNA";
$rev_complementary{"TNT"} = "ANA";

$rev_complementary{"NAA"} = "TTN";
$rev_complementary{"NAG"} = "CTN";
$rev_complementary{"NAC"} = "GTN";
$rev_complementary{"NAT"} = "ATN";

$rev_complementary{"NGA"} = "TCN";
$rev_complementary{"NGT"} = "ACN";
$rev_complementary{"NGC"} = "GCN";
$rev_complementary{"NGG"} = "CCN";

$rev_complementary{"NCA"} = "TGN";
$rev_complementary{"NCG"} = "CGN";
$rev_complementary{"NCT"} = "AGN";
$rev_complementary{"NCC"} = "GGN";

$rev_complementary{"NTT"} = "AAN";
$rev_complementary{"NTA"} = "TAN";
$rev_complementary{"NTG"} = "CAN";
$rev_complementary{"NTC"} = "GAN";

#----------------------------
$rev_complementary{"ATG"} = "CAT";
$rev_complementary{"ATC"} = "GAT";
$rev_complementary{"ATA"} = "TAT";
$rev_complementary{"ATT"} = "AAT";		      
$rev_complementary{"AGT"} = "ACT";
$rev_complementary{"AGC"} = "GCT";
$rev_complementary{"AGA"} = "TCT";
$rev_complementary{"AGG"} = "CCT";
$rev_complementary{"ACG"} = "CGT";
$rev_complementary{"ACT"} = "AGT";	      
$rev_complementary{"ACA"} = "TGT";
$rev_complementary{"ACC"} = "GGT";
$rev_complementary{"AAA"} = "TTT";
$rev_complementary{"AAC"} = "GTT";
$rev_complementary{"AAT"} = "ATT";
$rev_complementary{"AAG"} = "CTT";

$rev_complementary{"CTT"} = "AAG";
$rev_complementary{"CTG"} = "CAG";
$rev_complementary{"CTC"} = "GAG";
$rev_complementary{"CAT"} = "ATG";
$rev_complementary{"CAA"} = "TTG";
$rev_complementary{"CAC"} = "GTG";
$rev_complementary{"CAG"} = "CTG";
$rev_complementary{"CCC"} = "GGG";
$rev_complementary{"CCA"} = "TGG";
$rev_complementary{"CCT"} = "AGG";
$rev_complementary{"CCG"} = "CGG";
$rev_complementary{"CGA"} = "TCG";
$rev_complementary{"CGT"} = "ACG";
$rev_complementary{"CGC"} = "GCG";
$rev_complementary{"CGG"} = "CCG";

$rev_complementary{"TTT"} = "AAA";
$rev_complementary{"TTC"} = "GAA";
$rev_complementary{"TTG"} = "CAA";
$rev_complementary{"TAG"} = "CTA";
$rev_complementary{"TAA"} = "TTA";
$rev_complementary{"TAC"} = "GTA";
$rev_complementary{"TAT"} = "ATA";
$rev_complementary{"TCT"} = "AGA";
$rev_complementary{"TCG"} = "CGA";
$rev_complementary{"TCC"} = "GGA"; 
$rev_complementary{"TGT"} = "ACA";
$rev_complementary{"TGG"} = "CCA";
$rev_complementary{"TGA"} = "TCA";
$rev_complementary{"TGC"} = "GCA";

$rev_complementary{"GGG"} = "CCC";
$rev_complementary{"GGT"} = "ACC";
$rev_complementary{"GGA"} = "TCC";
$rev_complementary{"GGC"} = "GCC";
$rev_complementary{"GAG"} = "CTC";
$rev_complementary{"GAT"} = "ATC";
$rev_complementary{"GAC"} = "GTC";
$rev_complementary{"GAA"} = "TTC";
$rev_complementary{"GTA"} = "TAC";
$rev_complementary{"GTC"} = "GAC";
$rev_complementary{"GTG"} = "CAC";
$rev_complementary{"GTT"} = "AAC";
$rev_complementary{"GCC"} = "GGC";
$rev_complementary{"GCA"} = "TGC";
$rev_complementary{"GCG"} = "CGC";
$rev_complementary{"GCT"} = "AGC";



my %NUCLEOTIDE;
$NUCLEOTID{"A"} = "T";
$NUCLEOTID{"T"} = "A";
$NUCLEOTID{"C"} = "G";
$NUCLEOTID{"G"} = "C";

sub reverse{
    my $self = shift;
    my $tmp = shift;
    $tmp =~ s/Y|M|R|K|S|W|B|D|H|V/N/gi;    #ersetzen durch N
    return $rev_complementary{$tmp};
}


sub complement_nuc{
    my $self = shift;
    my $tmp = shift;
    return $NUCLEOTID{$tmp};
}

my %codon;
#$codon{} = 'A';        #Ala            Alanin
#$codon{} = 'R';        #Arg            Arginine
#$codon{} = 'N';        #Asn            Asparagine
#$codon{} = 'D';        #Asp            Aspartic acid
#$codon{} = 'C';        #Cys            Cysteine
#$codon{} = 'Q';        #Gln            Glutamine
#$codon{} = 'E';        #Glu            Glutamic acid
#$codon{} = 'G';        #Gly            Glycine
#$codon{} = 'H';        #His            Histidine
#$codon{} = 'I';        #Ile            Isoleucine
#$codon{} = 'L';        #Leu            Leucine
#$codon{} = 'K';        # Lys            Lysine
#$codon{} = 'M';        #Met            Methionine
#$codon{} = 'F';        #Phe            Phenylalanine
#$codon{} = 'P';        #Pro            Proline
#$codon{} = 'S';        #Ser            Serine
#$codon{} = 'T';        #Thr            Threonine
#$codon{} = 'W';        #Trp            Tryptophan
#$codon{} = 'Y';        #Tyr            Tyrosine
#$codon{} = 'V';        #Val            Valine
#$codon{} = 'B';        #Asx            Aspartic acid or Asparagine
#$codon{} = 'Z';        #Glx            Glutamine or Glutamic acid	

sub translate{
    my $self = shift; 
    my $triplet = shift;
    return $codon{$triplet} if ($codon{$triplet});
    return 'X';
}
return 1;
