#!/usr/bin/perl 

package Element;
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
# author mt
# Element object to store id, start and end position, complement, score 
# and comment of a gene.
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# CONSTRUCTOR.
#@param id
#@param start
#@param end
#@param score
#@param comment
#-----------------------
sub new{
    my $self = { };
    bless $self, shift;
    $self->id($_[0]);
    $self->start($_[1]);
    $self->end($_[2]);
    $self->complement($_[3]);
    $self->score($_[4]);
    $self->comment($_[5]);
    return $self;
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param id
#@return id
#------------------------
sub id{
    my ($self, $tmp) = @_;
    $self->{ID} = $tmp if($tmp);
    return $self->{ID};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param startposition (should be an integer) 
#@return current startposition or -1 if an error occured. 
#------------------------
sub start{
    my($self, $tmp) = @_;
    if ($tmp){
	return -1 if ($tmp =~ /\D/);
	$self->{START} = $tmp;
    }
    return $self->{START};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param end position (should be an integer) 
#@return current end position or -1 if an error occured. 
#------------------------
sub end{
    my($self, $tmp) =@_;
    if ($tmp){
	return -1 if ($tmp =~ /\D/);
	$self->{END} = $tmp;
    }
    return $self->{END};
}


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @param complement to set  
# @return complement
#------------------------
sub complement{
    my ($self, $tmp) = @_;
    $self->{COMPLEMENT} = uc$tmp if($tmp);
    return $self->{COMPLEMENT};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @param score to set 
# @return score
#------------------------
sub score{
    my ($self, $tmp) = @_;
    $self->{SCORE} = $tmp if($tmp);
    return $self->{SCORE};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param comment of arbitrary type
#@return comment 
#------------------------
sub comment{
    my($self, $tmp) =@_;
    $self->{COMMENT} = $tmp if($tmp);
    return $self->{COMMENT};
}


sub rbs{
    my ($self, $tmp) = @_;
    $self->{RBS} = $tmp if($tmp);
#    my ($self, @tmp);
#    ($self, $tmp[0], $tmp[1]) = @_;
#    if ($tmp[0]){$self->{RBS} = @tmp;}
    return $self->{RBS};
}


return 1;

