#!/usr/bin/perl

package ResultSet;
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
# author mt
# Object to hold result objects.  
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
use YACOP::gene_pred::Result;

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# CONSTRUCTOR.
#-----------------------
sub new{
    my $self= { };
    bless $self, shift;
    $self->{COUNTER}=0;
    return $self; 
} 

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Given id is added to result set. Values are store at given id of 
# stopCodon with the type as id. 
#@param type like 'glimmer' 'critica'
#@param $id position StopCodon 
#@param $val_id id of adjacent stop codon in the results
#---------------------------
sub add_result{
    my ($self, $type, $id, $val_id) = @_;
    return -1 if (!$id);
    if (!$self->{RESULTS}{$id}){
	$self->{COUNTER}++;
	$self->{RESULTS}{$id} = Result->new();
    } 
    $self->{RESULTS}{$id}->value($type, $val_id);
}


#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# removing result with given id. if type is given, only the value of 
# resp. type is removed, otherwise the entire result will be deleted. 
#@param $id (position of stop)
#@parap $type (optional) 
#----------------------------
sub remove_element{
    my ($self, $id, $type)=@_;
    return -1 if(!$id);
    if($type){
	$self->{RESULTS}{$id}->remove($type);
    }
    else{
	undef $self->{RESULTS}{$id};
    }
}


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# sets given result to given id
# @param Result $result
# @param num $id id of stopcodon
#---------------------------
sub set_result{
    my ($self, $id, $result) = @_;
     $self->{RESULTS}{$id} = $result;
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @return an array holding result ids
#---------------------------
sub get_all_results{
    my $self = shift;
    return keys %{$self->{RESULTS}};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param id of the StopCodon
#@return the Result (incident to ids)
#---------------------------
sub get_result{
    my ($self, $id) = @_;
    return -1 if (!$id);
    return $self->{RESULTS}{$id};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@return counted results.
#---------------------------
sub get_counter{
    my $self = shift;
    return $self->{COUNTER};
}
return 1;

