#!/usr/bin/perl

package StopCodon;
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
# author mt
# Stopcodons are taa, tag, and tga whereas deprecated bases are allowed.
# deprecated bases found in reverse codons are treated as N 
# Start is the position of the first base of the codon or the last, 
# if it is reverse complement. 
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
use Bio::Tools::CodonTable;
#use YACOP::gene_pred::CodonTable;

my %rev_complementary;;
$rev_complementary{"CTA"} = "TAG";
$rev_complementary{"TTA"} = "TAA";
$rev_complementary{"TCA"} = "TGA";
#reverse stop with degenerated nucs
$rev_complementary{"NNN"} = "NNN";
$rev_complementary{"CTN"} = "NAG";
$rev_complementary{"CNN"} = "NNG";
$rev_complementary{"NTN"} = "NAN";
$rev_complementary{"NNA"} = "TNN";
$rev_complementary{"CNA"} = "TNG";
$rev_complementary{"NTA"} = "TAN";
$rev_complementary{"TTN"} = "NAA";
$rev_complementary{"NCA"} = "TGN";
$rev_complementary{"NCN"} = "NGN";
$rev_complementary{"TCN"} = "NGA";
$rev_complementary{"TNN"} = "NNA";
$rev_complementary{"TNA"} = "TNA";
#----------------------------
$rev_complementary{"ATG"} = "CAT";
$rev_complementary{"ATC"} = "GAT";
$rev_complementary{"ATA"} = "TAT";
$rev_complementary{"ATT"} = "AAT";		      
$rev_complementary{"AGT"} = "ACT";
$rev_complementary{"AGC"} = "GCT";
$rev_complementary{"AGA"} = "TCT";
$rev_complementary{"AGG"} = "CCT";
$rev_complementary{"ACG"} = "CGT";
$rev_complementary{"ACT"} = "AGT";	      
$rev_complementary{"ACA"} = "TGT";
$rev_complementary{"ACC"} = "GGT";
$rev_complementary{"AAA"} = "TTT";
$rev_complementary{"AAC"} = "GTT";
$rev_complementary{"AAT"} = "ATT";
$rev_complementary{"AAG"} = "CTT";

$rev_complementary{"CTT"} = "AAG";
$rev_complementary{"CTG"} = "CAG";
$rev_complementary{"CTC"} = "GAG";
$rev_complementary{"CAT"} = "ATG";
$rev_complementary{"CAA"} = "TTG";
$rev_complementary{"CAC"} = "GTG";
$rev_complementary{"CAG"} = "CTG";
$rev_complementary{"CCC"} = "GGG";
$rev_complementary{"CCA"} = "TGG";
$rev_complementary{"CCT"} = "AGG";
$rev_complementary{"CCG"} = "CGG";
$rev_complementary{"CGA"} = "TCG";
$rev_complementary{"CGT"} = "ACG";
$rev_complementary{"CGC"} = "GCG";
$rev_complementary{"CGG"} = "CCG";

$rev_complementary{"TTT"} = "AAA";
$rev_complementary{"TTC"} = "GAA";
$rev_complementary{"TTG"} = "CAA";
$rev_complementary{"TAG"} = "CTA";
$rev_complementary{"TAA"} = "TTA";
$rev_complementary{"TAC"} = "GTA";
$rev_complementary{"TAT"} = "ATA";
$rev_complementary{"TCT"} = "AGA";
$rev_complementary{"TCG"} = "CGA";
$rev_complementary{"TCC"} = "GGA"; 
$rev_complementary{"TGT"} = "ACA";
$rev_complementary{"TGG"} = "CCA";
$rev_complementary{"TGA"} = "TCA";
$rev_complementary{"TGC"} = "GCA";

$rev_complementary{"GGG"} = "CCC";
$rev_complementary{"GGT"} = "ACC";
$rev_complementary{"GGA"} = "TCC";
$rev_complementary{"GGC"} = "GCC";
$rev_complementary{"GAG"} = "CTC";
$rev_complementary{"GAT"} = "ATC";
$rev_complementary{"GAC"} = "GTC";
$rev_complementary{"GAA"} = "TTC";
$rev_complementary{"GTA"} = "TAC";
$rev_complementary{"GTC"} = "GAC";
$rev_complementary{"GTG"} = "CAC";
$rev_complementary{"GTT"} = "AAC";
$rev_complementary{"GCC"} = "GGC";
$rev_complementary{"GCA"} = "TGC";
$rev_complementary{"GCG"} = "CGC";
$rev_complementary{"GCT"} = "AGC";

#-----------------------------
#taa, tag, and tga
my %STOP;
$STOP{"TAA"} = 'F';
$STOP{"TGA"} = 'F';
$STOP{"TAG"} = 'F';
#---- r: a/g
$STOP{"TAR"} = 'F';
$STOP{"TRA"} = 'F';
$STOP{"TRR"} = 'F';
$STOP{"TGR"} = 'F';
$STOP{"TRG"} = 'F';
#---- y: t/c
$STOP{"YAA"} = 'F';
$STOP{"YAG"} = 'F';
$STOP{"YGA"} = 'F';
#---- m: a/c
$STOP{"TMG"} = 'F';
$STOP{"TMM"} = 'F';
$STOP{"TMA"} = 'F';
$STOP{"TGM"} = 'F';
$STOP{"TAM"} = 'F';
#---- k: g/t
$STOP{"KAA"} = 'F';
$STOP{"KAG"} = 'F';
$STOP{"TKA"} = 'F';
$STOP{"TAK"} = 'F';
$STOP{"KKA"} = 'F';
$STOP{"KAK"} = 'F';
$STOP{"KGA"} = 'F';
#---- s: g/c
$STOP{"TAS"} = 'F';
$STOP{"TSA"} = 'F';
#---- w: a/t
$STOP{"WAG"} = 'F';
$STOP{"WWG"} = 'F';
$STOP{"TWG"} = 'F';
$STOP{"WWW"} = 'F';
$STOP{"TWW"} = 'F';
$STOP{"TWA"} = 'F';
$STOP{"WWA"} = 'F';
$STOP{"WGA"} = 'F';
$STOP{"WGW"} = 'F';
$STOP{"TGW"} = 'F';
$STOP{"TAW"} = 'F';
$STOP{"WAW"} = 'F';
#---- b: t/g/c 
$STOP{"BAG"} = 'F';
$STOP{"BAB"} = 'F';
$STOP{"TAB"} = 'F';
$STOP{"BAA"} = 'F';
$STOP{"BGA"} = 'F';
$STOP{"BBA"} = 'F';
$STOP{"TBA"} = 'F';
#---- d: a/g/t 
$STOP{"DDD"} = 'F';
$STOP{"DAG"} = 'F';
$STOP{"DDG"} = 'F';
$STOP{"TDG"} = 'F';
$STOP{"TDD"} = 'F';
$STOP{"DAA"} = 'F';
$STOP{"TAD"} = 'F';
$STOP{"TDA"} = 'F';
$STOP{"DDA"} = 'F';
$STOP{"DAA"} = 'F';
$STOP{"DGD"} = 'F';
#---- h: a/c/t
$STOP{"HAG"} = 'F';
$STOP{"HHG"} = 'F';
$STOP{"THG"} = 'F';
$STOP{"HHH"} = 'F';
$STOP{"HAA"} = 'F';
$STOP{"HHA"} = 'F';
$STOP{"THH"} = 'F';
$STOP{"THA"} = 'F';
$STOP{"HGH"} = 'F';
$STOP{"TGH"} = 'F';
$STOP{"HGA"} = 'F';
#---- v: a/g/c
$STOP{"TVG"} = 'F';
$STOP{"TVV"} = 'F';
$STOP{"TAV"} = 'F';
$STOP{"TVA"} = 'F';
$STOP{"TGV"} = 'F';
#---- n: a/g/t/c (for complement all degenerated are n)
$STOP{"NNN"} = 'R';
$STOP{"NAG"} = 'R';
$STOP{"NNG"} = 'R';
$STOP{"NAN"} = 'R';
$STOP{"TNN"} = 'R';
$STOP{"TNG"} = 'R';
$STOP{"TAN"} = 'R';
$STOP{"TNA"} = 'R';
$STOP{"TGN"} = 'R';
$STOP{"NGN"} = 'R';
$STOP{"NGA"} = 'R';
$STOP{"NNA"} = 'R';
$STOP{"NAA"} = 'R';

my $TABLE = Bio::Tools::CodonTable->new();
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# CONSTRUCTOR.
#@param id
#@param codon
#@param start
#@param end
#@param complement
#-----------------------
sub new{
    my $self = { };
    bless $self, shift;
    $self->id(shift);
    $self->codon(shift);
    $self->start(shift);
    $self->complement(shift);
    return $self;
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# CLASSROUTINE for testing if given codon stopcodon 
#@param codon
#@return codon is stop, 0 if not
#-----------------------
sub is_stop{
    my ($self, $codon) = @_;
    if ($STOP{$codon}){return $codon;} 
    return 0;
}     

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# CLASSROUTINE for testing if reverse complement of given codon is a 
# stopcodon 
# note: alle degenerated nucleotides are set to N
#@param codon
#@return reverse complementary of codon if it is a terminal codon, 0 if not
#-----------------------
sub is_complement_stop{
    my ($self, $codon) = @_;
    $codon =~ s/Y|M|R|K|S|W|B|D|H|V/N/gi;    #ersetzen durch N
    if ($STOP{$rev_complementary{$codon}}){
	return $rev_complementary{$codon};}
#    if ($STOP{CodonTable->reverse($codon)}){    
#	return CodonTable->reverse($codon);}
    return 0;
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param id
#@return id 
#-----------------------
sub id{
    my ($self, $tmp) = @_;
    $self->{ID} = $tmp if ($tmp);
    return $self->{ID};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param start (should be an integer)
#@return start or -1 if an error occured. 
#------------------------
sub start{
    my($self, $tmp) = @_;
    if ($tmp && $tmp >0){
	return -1 if($tmp =~ /\D/);
	$self->{START} = $tmp;}
    return $self->{START};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param character F or R for Forward and Reverse 1-3 for reading frame
#@param char
# @return the complement from which the stop codon is (F1,... R3).
#------------------------
sub complement{
    my ($self, $tmp) = @_;
    if ($tmp){
	chomp($tmp);
	$self->{COMPLEMENT} = $tmp if($tmp =~ /\b[FR].?\b/);
    }
    return $self->{COMPLEMENT};
}


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#@param sequence of stop codon, must be a real codon
#@return codon sequence or -1 if an error occured
#------------------------
sub codon{
    my ($self, $tmp) = @_;
    if ($tmp){
	return -1 if($TABLE->is_unknown_codon($tmp));
	$self->{CODON} = $tmp;
    }
    return $self->{CODON};
}
return 1;
